#ifndef f_INFILE_H
#define f_INFILE_H

class inFile {

private:
	enum { BUF_SIZE = 4096 };

	typedef union {
		struct {         
			DWORD	dwLo;
			LONG	lHi;
		};               
		__int64	i64;  
	} PTR64;

	BYTE	bBuff[BUF_SIZE];
	PTR64	fPos;
	PTR64	fSize;
	HANDLE	hFile;

	void inRefresh();

	HANDLE dualCreateFile(LPCWSTR lpFileName, DWORD dwDesiredAccess,
		DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes,
		DWORD dwCreationDisposition, DWORD dwFlagsAndAttributes,
		HANDLE hTemplateFile);

public:
	inFile::inFile();
	inFile::~inFile();

	bool inOpen(const wchar_t *szFile);

	__int64 inSize();
	__int64 inPos();
	bool inEOF();

	bool inSeek(__int64 iAbsPos);

	long inRead(void *lpBuffer, long lBytes);
	int inByte();
};

#endif	// f_INFILE_H